/***************************************************************************
					Author :      Muddassar Farooq
          Organizaton:  The University of New South Wales

          Date Started : October 1, 1998
          Date Ended   : November 22 , 1998.
          Main Module : vncviewer.java

          other Modules : animatedMemoryImageSource.java,
          authenticationPanel.java,ButtonPanel.java,
          clipBoardFrame.java, DesCipher.java,optionsFrame.java,
          rfbProto.java, TimeEvent.java, TimeOut.java, vncCanvas.java,

          This programs has been modified under GNU license as allowed by
					its distributor Olivetti & Oracle Research Laboratory. The purpose
          was to upgrade this software to new java 1.1 event model and get
					rid of all deprecated APIs. Moreover to make this software more an
          application than an applet. Following modifications are done in the
          interface

						1. One can start it as an application by typing
            			java vncviewer host:display.
						2. One can send a middle click as a double click
            3. Scroll Pane is added to take care of large display area.
            4. Software is documented in a manner that conforms to principle
            of software Engineering so that its understanding and modifications
	          become easy.


****************************************************************************/

//
//  Copyright (C) 1997, 1998 Olivetti & Oracle Research Laboratory
//
//  This is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This software is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this software; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
//  USA.
//


//
// The panel which implements the user authentication scheme. It has two
// important components i.e textfield and ok button. The user types his
// password in the textfield and then presses enter ot ok button. The
// whole panel implements interface listener because this is necessary to
// make it owner of the object.
//

import java.awt.*;
import java.awt.event.*;


class authenticationPanel extends Panel implements ActionListener {

  Label title, retry, prompt;
  TextField password;
  Button ok;

  //
  // Constructor.
  //

  public authenticationPanel() {

    title = new Label("VNC Authentication",Label.CENTER);
    title.setFont(new Font("Helvetica", Font.BOLD, 18));

    prompt = new Label("Password:",Label.CENTER);

// Defining a TextField and making * appear while user presses * and adding
// action listener for this.

    password = new TextField(10);
    password.setForeground(Color.black);
    password.setBackground(Color.white);
    password.setEchoChar('*');
    password.addActionListener(this);

    ok = new Button("OK");
    ok.addActionListener(this);


    retry = new Label("",Label.CENTER);
    retry.setFont(new Font("Courier", Font.BOLD, 16));

// Defining GridBagLayOut for this panel and also its contraints.

    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints gbc = new GridBagConstraints();

    setLayout(gridbag);

    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gridbag.setConstraints(title,gbc);
    add(title);

    gbc.fill = GridBagConstraints.HORIZONTAL;
    gridbag.setConstraints(retry,gbc);
    add(retry);

    gbc.fill = GridBagConstraints.NONE;
    gbc.gridwidth = 1;
    gridbag.setConstraints(prompt,gbc);
    add(prompt);

    gridbag.setConstraints(password,gbc);
    add(password);

    gbc.ipady = 10;
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbc.fill = GridBagConstraints.BOTH;
    gbc.insets = new Insets(0,20,0,0);
    gbc.ipadx = 40;
    gridbag.setConstraints(ok,gbc);
    add(ok);

    password.requestFocus();
  }



	//
  // actionPerformed(ActionEvnt e) is called when a button is pressed or
  // return is pressed in the password text field. This needs to be
  // synchronized so that it becomes the owner of object and then notifies
  // authenticator in vncviewer.java that is witing for output from here.
  //


	public synchronized void actionPerformed(ActionEvent e) {
		notify();

	}

  //
  // retry().
  //

  public void retry() {
    retry.setText("Sorry. Try again.");
    password.setText("");
  }

}
