/***********************************************
     Author :      Muddassar Farooq
     Organizaton:  The University of New South Wales

     Date Started : October 1, 1998
     Date Ended   : November 22 , 1998.
     Main Module : vncviewer.java

     other Modules : animatedMemoryImageSource.java,
     authenticationPanel.java,ButtonPanel.java,
     clipBoardFrame.java, DesCipher.java,optionsFrame.java,
     rfbProto.java, TimeEvent.java, TimeOut.java, vncCanvas.java,

     This programs has been modified under GNU license as allowed by                                      
     its distributor Olivetti & Oracle Research Laboratory. The purpose
     was to upgrade this software to new java 1.1 event model and get
     rid of all deprecated APIs. Moreover to make this software more an
     application than an applet. Following modifications are done in the applet
     
     1. One can start it as an application by typing
        java vncviewer host:display.
     2. One can send a middle click as a double click
     3. Scroll Pane is added to take care of large display area.
     4. Software is documented in a manner that conforms to principle
        of software Engineering so that its understanding and modifications
        become easy.


****************************************************************************/
//

//
//  Copyright (C) 1997, 1998 Olivetti & Oracle Research Laboratory
//
//  This is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This software is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this software; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
//  USA.
//

//
// Clipboard frame.
//

import java.awt.*;
import java.awt.event.*;

class clipboardFrame extends Frame implements ActionListener {

    TextArea ta;
    Button clear, dismiss;
    String selection;
    vncviewer v;


    //
    // Constructor.
    //

    clipboardFrame(vncviewer v1) {
        super("VNC Clipboard");

        this.enableEvents(FocusEvent.FOCUS_LOST);


        v = v1;

        GridBagLayout gridbag = new GridBagLayout();
        setLayout(gridbag);

        GridBagConstraints gbc = new GridBagConstraints();
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weighty = 1.0;

        ta = new TextArea(5, 40);
        gridbag.setConstraints(ta, gbc);
        add(ta);

        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.weightx = 1.0;
        gbc.weighty = 0.0;
        gbc.gridwidth = 1;
        clear = new Button("Clear");
        gridbag.setConstraints(clear, gbc);
        clear.addActionListener(this);
        clear.setActionCommand("Clear");
        add(clear);

        dismiss = new Button("Dismiss");
        gridbag.setConstraints(dismiss, gbc);
        dismiss.addActionListener(this);
        dismiss.setActionCommand("Dismiss");
        add(dismiss);

        pack();
    }


    //
    // Set the cut text from the RFB server.
    //

    void setCutText(String text) {
        selection = text;
        ta.setText(text);
        if (isVisible()) {
            ta.selectAll();
        }
    }


    //
    // When the focus leaves the window, see if we have new cut text and if so
    // send it to the RFB server.
    //

    public void processFocusEvent(FocusEvent fe) {

        if (fe.getID() == FocusEvent.FOCUS_LOST) {
            if ((selection != null) && !selection.equals(ta.getText())) {
                selection = ta.getText();
                v.setCutText(selection);
            }
        }
    }


    //
    // Respond to an action i.e. button press
    //

    public void actionPerformed(ActionEvent e) {
        String command = e.getActionCommand();

        if (command.equals("Dismiss")) {
            setVisible(false);

        } else if (command.equals("Clear")) {
            ta.setText("");
        }

    }
}






